class point (int) =
  val mutable x : int
  method get_x : int
  method move : int -> unit
end
val p : point
class colored_point (int) (string) =
  val c : string
  val mutable x : int
  method color : string
  method get_x : int
  method move : int -> unit
end
class intref (int) =
  val mutable x : int
  method get : int
  method set : int -> unit
end
class 'a ref ('a) =
  val mutable x : 'a
  method get : 'a
  method set : 'a -> unit
end
class 'a sillycircle ('a) =
  constraint 'a = < move : int -> unit; .. >
  val mutable center : 'a
  method center : 'a
  method move : int -> unit
  method set_center : 'a -> unit
end
class 'a circle ('a) =
  constraint 'a = #point
  val mutable center : 'a
  method center : 'a
  method move : int -> unit
  method set_center : 'a -> unit
end
class 'a colored_circle ('a) =
  constraint 'a = #colored_point
  val mutable center : 'a
  method center : 'a
  method color : string
  method move : int -> unit
  method set_center : 'a -> unit
end
class printable_point (int) =
  val mutable x : int
  method get_x : int
  method move : int -> unit
  method print : unit
end
class printable_colored_point (int) (string) =
  val c : string
  val mutable x : int
  method color : string
  method get_x : int
  method move : int -> unit
  method print : unit
end
class functional_point (int) : 'a =
  val x : int
  method get_x : int
  method move : int -> 'a
end
class virtual comparable (unit) : 'a = virtual leq : 'a -> bool end
class int_comparable (int) : 'a =
  val x : int
  method leq : 'a -> bool
  method x : int
end
class protected_point (int) =
  val mutable x : int
  method bump : unit
  method get_x : int
  method protected move : int -> unit
end
module type POINT =
  sig
    class restricted_point (int) =
      val mutable x : int
      method bump : unit
      method get_x : int
      method protected move : int -> unit
    end
  end
module Point : POINT
module type ABSPOINT =
  sig
    class restricted_point (int) = method bump : unit method get_x : int end
  end
module Abspoint : ABSPOINT
